//去掉字符串头尾空格   
function trim(str) {   
    return str.replace(/(^\s*)|(\s*$)/g, "");   
}

/*function isUrl(str){   
	var reg=/^([hH][tT]{2}[pP]:\/\/|[hH][tT]{2}[pP][sS]:\/\/)(([A-Za-z0-9-~]+)\.)+([A-Za-z0-9-~\/])+$/;
	if(str == null || str == ''){
		return false;
	}
	 if(!reg.test(str)){ 
		return false;
	}
	return true;
	
} */ 

//校验中文、英文、数字、下划线
function checkCheEngNum(value){
	var reg = /^[\u4e00-\u9fa5_a-zA-Z0-9]+$/;
	if(value == null || value == ''){
		return false;
	}
	if(!reg.test(value)){
		return false;
	}
	return true;
}

//验证小数（正）
function checkFloat(value){
	var reg = /^([1-9]\d{0,9}|0)([.]?|(\.\d{1,2})?)$/; 
	if(value == null || value == ''){
		return false;
	}
	if(!reg.test(value)){
		return false;
	}
	return true;
}

//验证英文字符大小写
function checkEng(value){
	var reg = /^[A-Za-z]+$/;
	if(value == null || value == ''){
		return false;
	}
	if(!reg.test(value)){
		return false;
	}
	return true;
}

//校验手机号码	 
function checkMobile(mobile){
	var tell = /^(13|14|15|17|18)\d{9}$/;
	if(mobile == null || mobile == ''){
		return false;
	}
	if(!tell.test(mobile)){
		return false;
	}
	return true;
}

//校验固定电话
function checkPhone(phone){
	var tell = /^(0[0-9]{2,3}\-)+([2-9][0-9]{6,7})$/;
	if(phone == null || phone == ''){
		return false;
	}
	if(!tell.test(phone)){
		return false;
	}
	return true;
}

//校验邮箱
function checkEmail(email){
	var filter = /^[a-z0-9]+([._\\-]*[a-z0-9])*@([a-z0-9]+[-a-z0-9]*[a-z0-9]+.){1,63}[a-z0-9]+$/;
	if(email == null || email == ''){
		return false;
	}
	if(!filter.test(email)){
		return false;
	}
	return true;
}

//校验qq
function checkQQ(qq){
	//var filter = /^[1-9]\d{4,8}$/;
	var filter = /^\d{5,10}$/;
	if(qq == null || qq == ''){
		return false;
	}
	if(!filter.test(qq)){
		return false;
	}
	return true;
}

//正整数
function isPostInteger(num){
	var pat = /^[1-9]\d*$/;
	if(!pat.test(num)){
		return false;
	}else{
		return true;
	}
}

//非负整数
function isNonNegaInteger(num){
	var pat = /(^[1-9]+\d*$)|(^0$)/;
	if(!pat.test(num)){
		return false;
	}else{
		return true;
	}
}

function isUrl(str) { 
	var RegUrl = new RegExp(); 
	RegUrl.compile("^[A-Za-z]+://[A-Za-z0-9-_]+\\.[A-Za-z0-9-_%&\?\/.=]+$");//jihua.cnblogs.com 
	if (!RegUrl.test(str)) { 
		return false; 
	} 
	return true; 
}

//提示信息（弹框自动消失）
function msgInfo(msgInfo, type, succUrl){
	if("success" == type){
		layer.msg(msgInfo, {icon: 1}, function(){
			location.href = succUrl;
		});
	} else if("warn" == type){
		layer.msg(msgInfo, {icon: 3}, function(){
			location.href = succUrl;
		});
	} else {
	layer.msg(msgInfo, {icon: 5});
	}
}


//提示信息，根据class或id位置显示
function showMsg(msgInfo, str){
	layer.tips(msgInfo, str, {
		  tips: [2, '#000']
	});
}

//验证是否为媒体文件
function isMedia(type, value){
	var image_reg = /^(.JPEG|.jpeg|.JPG|.jpg|.GIF|.gif|.PNG|.png|.BMP|.bmp)$/;
	var voice_reg = /^(.MP3|.mp3|.WMA|.wma|.WAV|.wav|.AMR|.amr)$/;
	var video_reg = /^(.MP4|.mp4|.AVI|.avi|.WMV|.wmv|.RMVB|.rmvb|.RM|.rm|.MPG|.mpg|.MPEG|.mpeg)$/;
	
	if(value == null || value == ''){
		return false;
	}
	
	if("image" == type){
		return image_reg.test(value);
	}else if("voice" == type){
		return voice_reg.test(value);
	}else if("video" == type){
		return video_reg.test(value);
	}else{
		return false;
	}
}

//验证audio标签支持的格式
function isHtml5Media(value){
	var voice_reg = /^(.MP3|.mp3|.OGG|.ogg|.WAV|.wav)$/;
	
	if(value == null || value == ''){
		return false;
	}
	
	return voice_reg.test(value);
}

//自定义map
function Map() {
	 var struct = function(key, value) {
	  this.key = key;
	  this.value = value;
	 }
	 
	 var put = function(key, value){
	  for (var i = 0; i < this.arr.length; i++) {
	   if ( this.arr[i].key === key ) {
	    this.arr[i].value = value;
	    return;
	   }
	  }
	   this.arr[this.arr.length] = new struct(key, value);
	 }
	 
	 var get = function(key) {
	  for (var i = 0; i < this.arr.length; i++) {
	   if ( this.arr[i].key === key ) {
	     return this.arr[i].value;
	   }
	  }
	  return {};
	 }
	 
	 var remove = function(key) {
	  var v;
	  for (var i = 0; i < this.arr.length; i++) {
	   v = this.arr.pop();
	   if ( v.key === key ) {
	    continue;
	   }
	   this.arr.unshift(v);
	  }
	 }
	 
	 var size = function() {
	  return this.arr.length;
	 }
	 
	 var isEmpty = function() {
	  return this.arr.length <= 0;
	 } 
	 this.arr = new Array();
	 this.get = get;
	 this.put = put;
	 this.remove = remove;
	 this.size = size;
	 this.isEmpty = isEmpty;
}



//验证身份证
	  //身份验证	
		var Wi = [ 7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2, 1 ];// 加权因子   
		var ValideCode = [ 1, 0, 10, 9, 8, 7, 6, 5, 4, 3, 2 ];// 身份证验证位值.10代表X   
		function IdCardValidate(idCard) {
			idCard = trim(idCard.replace(/ /g, ""));
			if (idCard.length == 15) {
				return isValidityBrithBy15IdCard(idCard);
			} else if (idCard.length == 18) {
				var a_idCard = idCard.split("");// 得到身份证数组   
				if (isValidityBrithBy18IdCard(idCard)
						&& isTrueValidateCodeBy18IdCard(a_idCard)) {
					return true;
				} else {
					return false;
				}
			} else {
				return false;
			}
		}

		/**  
		 * 验证15位数身份证号码中的生日是否是有效生日  
		 * @param idCard15 15位书身份证字符串  
		 * @return  
		 */
		function isValidityBrithBy15IdCard(idCard15){   
	      var year =  idCard15.substring(6,8);   
	      var month = idCard15.substring(8,10);   
	      var day = idCard15.substring(10,12);   
	      var temp_date = new Date(year,parseFloat(month)-1,parseFloat(day));   
	      // 对于老身份证中的你年龄则不需考虑千年虫问题而使用getYear()方法   
	      if(temp_date.getYear()!=parseFloat(year)   
	              ||temp_date.getMonth()!=parseFloat(month)-1   
	              ||temp_date.getDate()!=parseFloat(day)){
	                return false;   
	        }else{ 
	            return true;   
	        }   
	  }  
	  
	  
		   /**  
		  * 验证18位数身份证号码中的生日是否是有效生日  
		  * @param idCard 18位书身份证字符串  
		  * @return  
		  */  
		function isValidityBrithBy18IdCard(idCard18){   
		    var year =  idCard18.substring(6,10);   
		    var month = idCard18.substring(10,12);   
		    var day = idCard18.substring(12,14);   
		    var temp_date = new Date(year,(parseFloat(month)-1),parseFloat(day));   
		    // 这里用getFullYear()获取年份，避免千年虫问题   
		    if(temp_date.getFullYear()!=parseFloat(year)   
		          ||temp_date.getMonth()!=parseFloat(month)-1   
		          ||temp_date.getDate()!=parseFloat(day)){ 
		            return false;   
		    }else{
		        return true;   
		    }
		}

		/**  
		 * 判断身份证号码为18位时最后的验证位是否正确  
		 * @param a_idCard 身份证号码数组  
		 * @return  
		 */  
		function isTrueValidateCodeBy18IdCard(a_idCard) {   
		    var sum = 0; // 声明加权求和变量   
		    if (a_idCard[17].toLowerCase() == 'x') {   
		        a_idCard[17] = 10;// 将最后位为x的验证码替换为10方便后续操作   
		    }   
		    for ( var i = 0; i < 17; i++) {   
		        sum += Wi[i] * a_idCard[i];// 加权求和   
		    }   
		    valCodePosition = sum % 11;// 得到验证码所位置   
		    if (a_idCard[17] == ValideCode[valCodePosition]) { 
		        return true;   
		    } else {
		        return false;
		    }
		}
		
		//时间戳转yyyy-MM-dd HH:mm:ss
		function date2Str(time){
			if(time == null || time == ''){
				return '';
			}
			
			var d = new Date(time);
			var year = d.getFullYear();
			var month = d.getMonth();
			if(parseInt(month) < parseInt(10)){
				month = '0' + month;
			}
			var date = d.getDate();
			if(parseInt(date) < parseInt(10)){
				date = '0' + date;
			}
			var hour = d.getHours();
			if(parseInt(hour) < parseInt(10)){
				hour = '0' + hour;
			}
			var minute = d.getMinutes();
			if(parseInt(minute) < parseInt(10)){
				minute = '0' + minute;
			}
			var second = d.getSeconds();
			if(parseInt(second) < parseInt(10)){
				second = '0' + second;
			}
			
			return year + '-' + month + '-' + date + ' ' + hour + ':' + minute + ':' + second;
		}
		
		// 获取支付通道
		function getChannels(){
		    plus.payment.getChannels(function(channels){
		        for(var i in channels){
					var channel=channels[i];
					if(channel.id == 'alipay'){
						alipayChannel = channel;
					}else if(channel.id == 'wxpay'){
						wxChannel = channel;
					}
				}
		    },function(e){
		        mui.toast("获取支付通道失败："+e.message);
		    });
		}
		
		//根据用户选择支付通道，向支付宝或微信发起支付请求
		function payment(channel, orderString, payType, succCallback){
			plus.payment.request(channel, orderString, function(result){
				if(result == null){
					mui.alert('支付失败');
				}else{
					if (payType = '1') {
						var resultJson = JSON.parse(result.rawdata);
						if('9000' == resultJson.resultStatus){
							//判断是否为函数
							if(typeof succCallback === "function") {
			                    succCallback();
			                }
						}else{
							mui.alert('支付失败，' + resultJson.resultStatus);
						}
					}else if (payType = '2') {
						//TODO:微信
					}
				}
	        },function(error){
	        	var msg = error.message;
	        	if(msg.indexOf('62001') > -1 || msg.indexOf('User canceled')){
	        		//mui.toast('放弃了'+paymsg+'支付');
	        	}else{
	        		mui.toast(msg);	
	        	}
	        });
		}
		
		//根据id关闭页面，传值时支持过个id
		function closeHtml(){
			var len = arguments.length; // 获取被传递参数的长度
			if (len != undefined && len > 0) {
				for (var i = 0; i < len; i++) {
					var htmlId = plus.webview.getWebviewById(arguments[i]);
					if (htmlId != undefined && htmlId != null) {
						plus.webview.close(htmlId, 'none', 0, {});
					}
				}
			}
		}
		
		//触发'我的'页面的事件，修改用户vip状态
		function refreshMineVipState(isVip){
			var mineHtml = plus.webview.getWebviewById('/views/mine.html');
		  	mui.fire(mineHtml,'refreshIsVip', {'isVip': isVip});
		}
