function checkDom(dom){
	if(dom == null){
		return false;
	}
	var value = dom.value;
	var id = dom.getAttribute('id');
	var tip = document.getElementById(id + 'Tip');
	if(value == null || value == ''){
		tip.style.display = 'block';
		return false;
	}else{
		tip.style.display = 'none';
		return true;
	}
}

function checkPsgName(dom){
	if(dom == null){
		return false;
	}
	var value = dom.value;
	var id = dom.getAttribute('id');
	var tip = document.getElementById(id + "Tip");
	if(value == null || value == ''){
		tip.innerHTML = '请填写乘机人姓名';
		tip.style.display = 'block';
		return false;
	}else{
		tip.style.display = 'none';
	}
}

function checkCardNo(dom){
	if(dom == null){
		return false;
	}
	var value = dom.value;
	var id = dom.getAttribute('id');
	var tip = document.getElementById(id + "Tip");
	if(value == null || value == ''){
		tip.innerHTML = '请填写证件号码';
		tip.style.display = 'block';
		return false;
	}else{
		tip.style.display = 'none';
	}
	var cardType = document.getElementById(id.replace('cardNo', 'cardType'));
	//校验身份证号码
	if(cardType.selectedIndex == 0){
		if(!IdCardValidate(value)){
			tip.innerHTML = '请填写正确的身份证号码';
			tip.style.display = 'block';
			return false;
		}else{
			tip.style.display = 'none';
			return true;
		}
	}else{
		return true;
	}
}
	
	var tell= /^(13|14|15|17|18|19)\d{9}$/;
	function checkMobile(dom){
		var tip = document.getElementById(dom.getAttribute('id') + "Tip");
		var value = dom.value;
		if(value == null || value == ''){
			tip.innerHTML = '请输入手机号码';
			tip.style.display = 'block';
			return false;
		}else{
			if(!tell.test(value)){
				tip.innerHTML = '手机号码格式有误';
				tip.style.display = 'block';
				return false;
			}
			tip.style.display = 'none';
				return true;
		}
	}
	
	var filter = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
	function checkEmail(dom){
		var tip = document.getElementById(dom.getAttribute('id') + "Tip");
	var value = dom.value;
	if(value == null || value == ''){
		tip.innerHTML = '请填写正确的邮箱地址';
		tip.style.display = 'block';
		return false;
	}else{
		if(!filter.test(value)){
			tip.innerHTML = '请填写正确的邮箱地址';
			tip.style.display = 'block';
			return false;
		}
		tip.style.display = 'none';
			return true;
		}
	}
	
	var postcode= /^[1-9][0-9]{5}$/;
	function checkPostCode(dom){
		var tip = document.getElementById(dom.getAttribute('id') + "Tip");
	var value = dom.value;
	if(value == null || value == ''){
		tip.innerHTML = '请填写邮政编码';
		tip.style.display = 'block';
		return false;
	}else{
		if(!postcode.test(value)){
			tip.innerHTML = '请填写正确的邮政编码';
			tip.style.display = 'block';
			return false;
		}
		tip.style.display = 'none';
			return true;
		}
	}

function hasAdt(birth){
	if(birth == null || birth == ''){
		return true;
	}
	var compareDate = new Date();
	var sysDate = new Date(compareDate);
	var time18 = new Date((sysDate.getFullYear()-12),(sysDate.getMonth()),sysDate.getDate());
	var birDate = new Date(birth);
	if((Math.ceil(birDate.getTime()/(1000*3600*24))-Math.ceil(time18.getTime()/(1000*3600*24))) <= 0){
		return true;
	}else{
		return false;
	}
}

function hasAdt(birth , compareDate){
	if(birth == null || birth == ''){
		return true;
	}
	if(compareDate == null){
		compareDate = new Date();
	}
	var sysDate = new Date(compareDate);
	var time18 = new Date((sysDate.getFullYear()-12),(sysDate.getMonth()),sysDate.getDate());
	var birDate = new Date(birth);
	if((Math.ceil(birDate.getTime()/(1000*3600*24))-Math.ceil(time18.getTime()/(1000*3600*24))) <= 0){
		return true;
	}else{
		return false;
	}
}

//从证件号码中获取生日，证件号码为空或是不合法返回null
function getBirthday(idCard){
	if(!IdCardValidate(idCard)){
		return null;
	}
	idCard = trim(idCard.replace(/ /g, ""));               //去掉字符串头尾空格                     
if (idCard.length == 15) {
  var year =  idCard.substring(6,8);   
    var month = idCard.substring(8,10);   
    var day = idCard.substring(10,12);   
    return '19'+year+'-'+month+'-'+day;
}else{
  var year =  idCard.substring(6,10);   
  var month = idCard.substring(10,12);   
  var day = idCard.substring(12,14);   
  return year+'-'+month+'-'+day;
    }
}

//身份验证	
var Wi = [ 7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2, 1 ];// 加权因子   
var ValideCode = [ 1, 0, 10, 9, 8, 7, 6, 5, 4, 3, 2 ];// 身份证验证位值.10代表X   
function IdCardValidate(idCard) {
	if(idCard == null || idCard == ''){
	return false;
}
idCard = trim(idCard.replace(/ /g, ""));
if (idCard.length == 15) {
	return isValidityBrithBy15IdCard(idCard);
} else if (idCard.length == 18) {
	var a_idCard = idCard.split("");// 得到身份证数组   
		if (isValidityBrithBy18IdCard(idCard)
				&& isTrueValidateCodeBy18IdCard(a_idCard)) {
			return true;
		} else {
			return false;
		}
	} else {
		return false;
	}
}

/**  
 * 验证15位数身份证号码中的生日是否是有效生日  
 * @param idCard15 15位书身份证字符串  
 * @return  
 */
function isValidityBrithBy15IdCard(idCard15){   
  var year =  idCard15.substring(6,8);   
  var month = idCard15.substring(8,10);   
  var day = idCard15.substring(10,12);   
  var temp_date = new Date(year,parseFloat(month)-1,parseFloat(day));   
  // 对于老身份证中的你年龄则不需考虑千年虫问题而使用getYear()方法   
      if(temp_date.getYear()!=parseFloat(year)   
              ||temp_date.getMonth()!=parseFloat(month)-1   
              ||temp_date.getDate()!=parseFloat(day)){
                return false;   
        }else{ 
            return true;   
        }   
    }  
  
  
	/**  
* 验证18位数身份证号码中的生日是否是有效生日  
* @param idCard 18位书身份证字符串  
* @return  
*/  
function isValidityBrithBy18IdCard(idCard18){   
    var year =  idCard18.substring(6,10);   
    var month = idCard18.substring(10,12);   
    var day = idCard18.substring(12,14);   
    var temp_date = new Date(year,(parseFloat(month)-1),parseFloat(day));   
    // 这里用getFullYear()获取年份，避免千年虫问题   
    if(temp_date.getFullYear()!=parseFloat(year)   
          ||temp_date.getMonth()!=parseFloat(month)-1   
          ||temp_date.getDate()!=parseFloat(day)){ 
            return false;   
    }else{
        return true;   
    }
}

/**  
 * 判断身份证号码为18位时最后的验证位是否正确  
 * @param a_idCard 身份证号码数组  
 * @return  
 */  
function isTrueValidateCodeBy18IdCard(a_idCard) {   
    var sum = 0; // 声明加权求和变量   
if (a_idCard[17].toLowerCase() == 'x') {   
a_idCard[17] = 10;// 将最后位为x的验证码替换为10方便后续操作   
}   
for ( var i = 0; i < 17; i++) {   
    sum += Wi[i] * a_idCard[i];// 加权求和   
}   
valCodePosition = sum % 11;// 得到验证码所位置   
    if (a_idCard[17] == ValideCode[valCodePosition]) { 
        return true;   
    } else {
        return false;
    }
}
	
//去掉字符串头尾空格   
function trim(str) {   
    return str.replace(/(^\s*)|(\s*$)/g, "");   
}
